#!/usr/bin/python3
import sqlite3

conn = sqlite3.connect('rh.db')
conn.row_factory = sqlite3.Row

output = open('rh-write.xml','w')


def encode(s):
    s = s.replace('&','&amp;')
    s = s.replace('<','&lt;')
    s = s.replace('>','&gt;')
    s = s.replace('\'','&apos;')
    s = s.replace('"','&quot;')

    return s


def export_rh():

    output.write('<?xml version="1.0" encoding="utf-8"?>')
    output.write('<!DOCTYPE rh SYSTEM "rh.dtd">')
    output.write('<rh>')

    export_bosses()

    output.write('</rh>')


def export_bosses():

    boss = conn.cursor()

    boss.execute('SELECT ID \
                  FROM EMPLOYE \
                  LEFT OUTER JOIN SUPERIEUR ON (EMPLOYE.ID = SUPERIEUR.ID_EMPLOYE) \
                  WHERE ID_SUPERIEUR IS NULL');

    for b in boss:
        export_employe(b['id'])

    boss.close()


def export_employe(emp_id) :

    emp = conn.cursor()

    emp.execute('SELECT E.NOM      as e_nom, \
                        E.PRENOM   as e_prenom, \
                        E.EMBAUCHE as e_embauche, \
                        E.SALAIRE  as e_salaire, \
                        D.NOM      as d_nom, \
                        D.VILLE    as d_ville \
                 FROM EMPLOYE E, DEPARTEMENT D \
                 WHERE E.ID = ? AND E.ID_DEPT = D.ID', (emp_id,))
    e = emp.fetchone()

    output.write('<employe id="%i">'%(emp_id,))
    output.write('<nom>%s</nom>' % encode(e['e_nom']))
    output.write('<prenom>%s</prenom>' % encode(e['e_prenom']))
    output.write('<embauche>%s</embauche>' % encode(e['e_embauche']))
    output.write('<salaire>%.0f</salaire>' % e['e_salaire'])
    output.write('<departement nom="%s" ville="%s"/>' % (encode(e['d_nom']),
                                                         encode(e['d_ville'])))
    emp.close()

    sub = conn.cursor()
    sub.execute('SELECT ID_EMPLOYE FROM SUPERIEUR WHERE ID_SUPERIEUR = ?', (emp_id,));

    for sub_emp in sub :
        export_employe(sub_emp['id_employe'])

    sub.close()

    output.write('</employe>')



if __name__ == '__main__':
    export_rh()

