#!/usr/bin/python

import sqlite3
from xml.sax.saxutils import XMLGenerator

conn = sqlite3.connect('rh.db')
conn.row_factory = sqlite3.Row

handler = XMLGenerator(open("rh-sax.xml",'w'),
                       encoding='utf-8',
                       short_empty_elements=True)


def export_rh():

    handler.startDocument()
    handler.startElement("rh",{})

    export_bosses()

    handler.endElement('rh')
    handler.endDocument()


def export_bosses():

    boss = conn.cursor()
    boss.execute('SELECT ID \
                  FROM EMPLOYE \
                  LEFT OUTER JOIN SUPERIEUR ON (EMPLOYE.ID = SUPERIEUR.ID_EMPLOYE) \
                  WHERE ID_SUPERIEUR IS NULL');

    for b in boss:
        export_employe(b['id'])

    boss.close()


def export_employe(emp_id) :

    emp = conn.cursor()
    emp.execute('SELECT E.NOM      as e_nom, \
                        E.PRENOM   as e_prenom, \
                        E.EMBAUCHE as e_embauche, \
                        E.SALAIRE  as e_salaire, \
                        D.NOM      as d_nom, \
                        D.VILLE    as d_ville \
                 FROM EMPLOYE E, DEPARTEMENT D \
                 WHERE E.ID = ? AND E.ID_DEPT = D.ID', (emp_id,))
    e = emp.fetchone()

    handler.startElement("employe",{'id':str(emp_id)})

    handler.startElement("nom",{})
    handler.characters(e["e_nom"])
    handler.endElement("nom")

    handler.startElement("prenom",{})
    handler.characters(e["e_prenom"])
    handler.endElement("prenom")

    handler.startElement("embauche",{})
    handler.characters(e["e_embauche"])
    handler.endElement("embauche")

    handler.startElement("salaire",{})
    handler.characters(str(e["e_salaire"]))
    handler.endElement("salaire")

    handler.startElement("departement",{'ville':e["d_ville"], 'nom':e["d_nom"]})
    handler.endElement("departement")


    sub = conn.cursor()
    sub.execute('SELECT ID_EMPLOYE FROM SUPERIEUR WHERE ID_SUPERIEUR = ?', (emp_id,));

    for sub_emp in sub :
        export_employe(sub_emp['id_employe'])

    sub.close()

    handler.endElement("employe")

if __name__ == "__main__":
    export_rh()
